local wagons = {
    "oilWagon01x",
    "utilliwag",
    "buggy02",
    "wagondoc01x",
    "gatchuck_2",
    "gatchuck",
    "cart03",
    "wagontraveller01x",
    "warwagon2",
    "chuckwagon000x",
    "coach3_cutscene",
    "wagonPrison01x",
    "stagecoach004_2x",
    "wagonCircus02x",
    "wagonCircus01x",
    "cart04",
    "supplywagon",
    "wagonarmoured01x",
    "policewagon01x",
    "cart08",
    "oilWagon02x",
    "coach4",
    "wagon06x",
    "huntercart01",
    "wagon05x_2",
    "wagon04x",
    "coal_wagon",
    "wagon02x",
    "buggy01",
    "stagecoach001x",
    "supplywagon2",
    "buggy03",
    "stagecoach006x",
    "cart07",
    "cart06",
    "coach3",
    "coach5",
    "wagon05x",
    "stagecoach003x",
    "stagecoach002x",
    "cart05",
    "chuckwagon002x",
    "coach6",
    "ArmySupplyWagon",
    "cart02",
    "bountywagon01x",
    "wagondairy01x",
    "stagecoach004x",
    "logwagon2",
    "wagon03x",
    "coach2",
    "cart01",
    "policeWagongatling01x",
    "logwagon",
    "wagonwork01x",
    "stagecoach005x"
}

local boats = {
    "pirogue2",
    "canoe",
    "rcBoat",
    "tugboat3",
    "canoeTreeTrunk",
    "boatsteam02x",
    "pirogue",
    "TugBoat2",
    "turbineboat",
    "smuggler02",
    "horseBoat",
    "rowboat",
    "ship_nbdGuama",
    "ship_nbdGuama2",
    "ship_guama02",
    "rowboatSwamp",
    "rowboatSwamp02",
    "skiff",
    "keelboat"
}

local others = {
    "privateflatcar01x",
    "GhostTrainPassenger",
    "GhostTrainSteamer",
    "midlandrefrigeratorcar",
    "privatesteamer01x",
    "gatlingMaxim02",
    "steamerDummy",
    "winterSteamer",
    "armoredCar01x",
    "wintercoalcar",
    "privateArmoured",
    "trolley01x",
    "northpassenger01x",
    "privateObservationcar",
    "coalHopper01x",
    "hotchkiss_cannon",
    "privatedining01x",
    "privateopensleeper01x",
    "caboose01x",
    "GhostTrainCoalCar",
    "breach_cannon",
    "privateboxcar01x",
    "privatebaggage01x",
    "privatecoalcar01x",
    "midlandboxcar05x",
    "northsteamer01x",
    "armoredCar03x",
    "gatling_gun",
    "privaterooms01x",
    "privatepassenger01x",
    "privateopensleeper02x",
    "northpassenger03x",
    "privateboxcar04x",
    "privateboxcar02x",
    "GhostTrainCaboose",
    "mineCart01x",
    "northcoalcar01x",
    "northflatcar01x",
    "hotAirBalloon01",
    "handcart"
}

Citizen.CreateThread(function()
    while DONE.Vehicle == nil do
        Citizen.Wait(100)
    end

	local sliderwagons = {}
	for _, wagon in pairs(wagons) do
		table.insert(sliderwagons, { label = wagon, value = wagon })
	end

	local wagonslider = DONE.Vehicle:AddSlider({ label = "Spawn wagon", value = 1, values = sliderwagons })
	wagonslider:On("select", function(btn, value)
		local ped = PlayerPedId()

		local model = GetHashKey(value)
		RequestModel(model)
		local _to = 0
		while not HasModelLoaded(model) and _to < 100 do
			_to = _to + 1
			Citizen.Wait(100)
		end

		if HasModelLoaded(model) then
			local lastVeh = GetVehiclePedIsIn(ped, true)
			if DoesEntityExist(lastVeh) then
                DeleteVehicle(lastVeh)
				DeleteEntity(lastVeh)
			end

			local coords = GetOffsetFromEntityInWorldCoords(ped, 0.0, 1.0, 0.0)
			local vehicle = CreateVehicle(model, coords.x, coords.y, coords.z, 0.0, true, true, false, false)
			while not DoesEntityExist(vehicle) do
				Citizen.Wait(10)
			end

            SetEntityAsMissionEntity(vehicle, true, true)

            SetVehicleFixed(vehicle)
            Citizen.InvokeNative(0xF89D82A0582E46ED, vehicle, 0)
            Citizen.InvokeNative(0x8268B098F6FCA4E2, vehicle, 0)
			
            SetModelAsNoLongerNeeded(model)

            SetPedIntoVehicle(ped, vehicle, -1)
		end
	end)

	local sliderboats = {}
	for _, wagon in pairs(boats) do
		table.insert(sliderboats, { label = wagon, value = wagon })
	end

	local boatslider = DONE.Vehicle:AddSlider({ label = "Spawn boat", value = 1, values = sliderboats })
	boatslider:On("select", function(btn, value)
		local ped = PlayerPedId()

		local model = GetHashKey(value)
		RequestModel(model)
		local _to = 0
		while not HasModelLoaded(model) and _to < 100 do
			_to = _to + 1
			Citizen.Wait(100)
		end

		if HasModelLoaded(model) then
			local lastVeh = GetVehiclePedIsIn(ped, true)
			if DoesEntityExist(lastVeh) then
                DeleteVehicle(lastVeh)
				DeleteEntity(lastVeh)
			end

			local coords = GetOffsetFromEntityInWorldCoords(ped, 0.0, 1.0, 0.0)
			local vehicle = CreateVehicle(model, coords.x, coords.y, coords.z, 0.0, true, true, false, false)
			while not DoesEntityExist(vehicle) do
				Citizen.Wait(10)
			end

            SetEntityAsMissionEntity(vehicle, true, true)

            SetVehicleFixed(vehicle)
            Citizen.InvokeNative(0xF89D82A0582E46ED, vehicle, 0)
            Citizen.InvokeNative(0x8268B098F6FCA4E2, vehicle, 0)
			
            SetModelAsNoLongerNeeded(model)

            SetPedIntoVehicle(ped, vehicle, -1)
		end
	end)
end)