local weather_types = {
    "BLIZZARD",
    "CLOUDS",
    "DRIZZLE",
    "FOG",
    "GROUNDBLIZZARD",
    "HAIL",
    "HIGHPRESSURE",
    "HURRICANE",
    "MISTY",
    "OVERCAST",
    "OVERCASTDARK",
    "RAIN",
    "SANDSTORM",
    "SHOWER",
    "SLEET",
    "SNOW",
    "SNOWLIGHT",
    "SUNNY",
    "THUNDER",
    "THUNDERSTORM",
    "WHITEOUT",
    -- ONLY SINGLEPLAYER:
    "SNOWCLEARING",
}

Citizen.CreateThread(function()
    while DONE.World == nil do
        Citizen.Wait(100)
    end

    local freezetime = DONE.World:AddCheckbox({ label = "Freeze time", value = "n" })
    local timefreezed = false
    freezetime:On("check", function(btn)
        timefreezed = true
        NetworkClearClockTimeOverride()
        SetClockTime(GetClockHours(), 0, 0)
        Citizen.InvokeNative(0x669E223E64B1903C, GetClockHours(), 0, 0, timefreezed)
    end)
    freezetime:On("uncheck", function(btn)
        timefreezed = false
        NetworkClearClockTimeOverride()
        SetClockTime(GetClockHours(), 0, 0)
        Citizen.InvokeNative(0x669E223E64B1903C, GetClockHours(), 0, 0, timefreezed)
    end)

    local sliderhours = {}
    for i=0, 23, 1 do
        table.insert(sliderhours, { label = i..":00", value = tostring(i) })
    end

    local sliderhour = DONE.World:AddSlider({ label = "Set time", value = "12", values = sliderhours, saveOnUpdate = true})
    sliderhour:On("select", function(btn, value)
        NetworkClearClockTimeOverride()
        SetClockTime(GetClockHours(), 0, 0)
        Citizen.InvokeNative(0x669E223E64B1903C, tonumber(value), 0, 0, timefreezed)
    end)

    local freezeweather = DONE.World:AddCheckbox({ label = "Freeze Weather", value = "n" })
    local weatherfreezed = false
    freezeweather:On("check", function(btn)
        weatherfreezed = true
        Citizen.InvokeNative(0xD74ACDF7DB8114AF, weatherfreezed)
    end)
    freezeweather:On("uncheck", function(btn)
        weatherfreezed = false
        Citizen.InvokeNative(0xD74ACDF7DB8114AF, weatherfreezed)
    end)

    local sliderweathers = {}

    for _, weather in pairs(weather_types) do
        table.insert(sliderweathers, { label = weather, value = weather })
    end

    local sliderweather = DONE.World:AddSlider({ label = "Set weather", value = 18, values = sliderweathers, saveOnUpdate = true})
    sliderweather:On("select", function(btn, value)
        ClearOverrideWeather()
        Citizen.InvokeNative(0x59174F1AFE095B5A, GetHashKey(value), true, false, true, 1, false)
        Citizen.InvokeNative(0xD74ACDF7DB8114AF, weatherfreezed)
    end)

    local showcoords = DONE.World:AddCheckbox({ label = "Show coords", value = "n" })
    local showcoordsThread = false
    showcoords:On("check", function(btn)
        showcoordsThread = true
        Citizen.CreateThread(function()
            while showcoordsThread do
                Citizen.Wait(1)
                local ped = PlayerPedId()
                local coords = GetEntityCoords(ped, false, true)
                DrawText(("%s, %s, %s"):format(math.round(coords.x, 3), math.round(coords.y, 3), math.round(coords.z, 3)), 0, 0.4, 0.5, 0.96, 255, 255, 255, 255, 1)
            end
        end)
    end)
    showcoords:On("uncheck", function(btn)
        showcoordsThread = false
    end)
end)