RGBRainbow = function(frequency) -- https://github.com/jorjic/fivem-docs/wiki/Making-Rainbow-Text
	local result = {}
	local curtime = GetGameTimer() / 1000

	result.r = math.floor( math.sin( curtime * frequency + 0 ) * 127 + 128 )
	result.g = math.floor( math.sin( curtime * frequency + 2 ) * 127 + 128 )
	result.b = math.floor( math.sin( curtime * frequency + 4 ) * 127 + 128 )
	
	return result
end

DrawText = function(text, font, scale, x, y, r, g, b, a, centre)
	if r == nil or g == nil or b == nil or a == nil then
		r = 255
		g = 255
		b = 255
		a = 255
	end


	local str = CreateVarString(10, "LITERAL_STRING", text)
	SetTextColor(r, g, b, a)
	SetTextScale(scale, scale)
	SetTextFontForCurrentCommand(font)
	SetTextCentre(centre or 0)
	SetTextDropshadow(1, 0, 0, 0, 255)
	DisplayText(str, x, y)
end

math.round = function(num, dp)
	local mult = 10^(dp or 0)
	return math.floor(num * mult + 0.5)/mult
end

local __genOrderedIndex = function(t)
    local orderedIndex = {}
    for key in pairs(t) do
        table.insert(orderedIndex, key)
    end
    table.sort(orderedIndex)
    return orderedIndex
end

local orderedNext = function(t, state)
    -- Equivalent of the next function, but returns the keys in the alphabetic
    -- order. We use a temporary ordered key table that is stored in the
    -- table being iterated.

    local key = nil
    --print("orderedNext: state = "..tostring(state) )
    if state == nil then
        -- the first time, generate the index
        t.__orderedIndex = __genOrderedIndex(t)
        key = t.__orderedIndex[1]
    else
        -- fetch the next value
        for i = 1, #t.__orderedIndex do
            if t.__orderedIndex[i] == state then
                key = t.__orderedIndex[i+1]
            end
        end
    end

    if key then
        return key, t[key]
    end

    -- no more value to return, cleanup
    t.__orderedIndex = nil
    return
end

orderedPairs = function(t)
    -- Equivalent of the pairs() function on tables. Allows to iterate
    -- in order
    return orderedNext, t, nil
end